# encoding:utf-8


require 'test/unit/assertions'

include Test::Unit::Assertions

def duration_in_seconds number, time_unit
  case time_unit
    when /^seconds?$/
      number
    when /^minutes?$/
      number * 60
    else
      raise StandardError, "Don't know how to turn '#{ time_unit }' into seconds… so sorry."
  end
end


Given /^this (?:.+?) takes (\d+) (\w+)$/ do | number, time_unit |

  @start_at ||= Time.now

  duration_in_secs = duration_in_seconds Integer( number ), time_unit

  puts "Waiting for '#{ number } #{ time_unit }' (#{ duration_in_secs } sec)"
  sleep duration_in_secs

end

Then /^the whole scenario should not take much more than (.+) (\w+)$/ do | number,  time_unit |

  actual_duration_in_sec = Time.now - @start_at
  expected_duration_in_sec =duration_in_seconds Float( number ), time_unit
  assert_in_delta( expected_duration_in_sec, actual_duration_in_sec, 2.0, "That went too slow or to fast…" )

end
